require 'json'

module Puppet::Parser::Functions
  newfunction(:parse_for_vib_path, :type => :rvalue, :doc => <<-EOS
This function takes in a string representing JSON array of uri_paths
and converts it to JSON array of parsed vib_path, nfs_share and volume_name for mountpoint
  EOS
  ) do |args|
    uri_paths = JSON.parse(args[0])
    uri_paths.each do |uri_path|
      full_path = uri_path["uri_path"]
      full_path_split = full_path.split('/')
      if full_path.start_with?("/var/nfs")
        uri_path[:vib_path] = full_path_split[5..-1].join('/')
        uri_path[:nfs_share] = full_path_split[0..4].join('/')
        uri_path[:volume_name] = full_path_split[4] # This is a unique GUID representing for repository => good candidate for volume name
      else
        uri_path[:vib_path] = full_path
      end
    end
    uri_paths
  end
end
